<template>
  <v-app>
    <Menu/>
    <v-layout row wrap>
      <LeftSidebar/>
      <v-flex class="editor" sm8 xs12>
        <v-form ref="form" v-model="valid">
          <v-text-field
            :rules="rules"
            disabled
            label="Название заметки"
            outline
            placeholder="Введите текст"
            required
            v-model="post.title"
          ></v-text-field>
          <Editor disabled label="Текст вашей заметки" v-model="post.text"/>
          <v-btn @click="submit">Разрешить публикацию на сайте</v-btn>
        </v-form>
      </v-flex>
    </v-layout>
  </v-app>
</template>

<script>
  import Editor from "@servicestack/editor";
  import Menu from '../components/Menu'
  import LeftSidebar from '../components/LeftSidebar'
  import axios from 'axios'

  export default {
    beforeRouteEnter(to, from, next) {
      // check user permissions
      next(vm => {
        let userProfile = JSON.parse(localStorage.getItem('profileStorage'))
        if (userProfile === null) {
          vm.$router.push('/login')
        }
        console.log('Logged in')
      })
    },
    components: {
      Menu,
      LeftSidebar,
      Editor
    },
    data() {
      return {
        rules: [
          (v) => !!v || 'Введите название',
        ],
        valid: false,
        userProfile: null,
        post: {title: 'Заголовок заметки загружается', text: 'Текст заметки загружается...'},
      }
    },
    created() {

      this.getPost(this.$route.params.id)

      this.$store.dispatch('getProfile')
        .then(() => {
          let profile = localStorage.getItem('profileStorage')
          this.userProfile = JSON.parse(profile)
        })

    },
    methods: {
      getPost(postID) {
        return axios.get('/api/posts/' + postID)
          .then(response => {
            this.post = response.data
          })
          .catch(e => {
            console.log(e)
          })
      },
      submit() {
        if (this.$refs.form.validate()) {
          let new_post = this.post
          new_post.is_approved = true
          let id = new_post.id
          let approved = new_post.is_approved
          this.$store.dispatch('approvePost', {approved, id})
            .then(() => this.$router.push({name: 'moderate'}))
            .catch(e => {
              console.log(e)
            })
        }
      }
    }
  }
</script>
<style lang="scss" scoped>
  .editor {
    padding-top: 20px;
  }

</style>

